/*
 * scamper.h
 *
 * $Id: scamper.h,v 1.32 2005/05/27 02:39:13 mjl Exp $
 *
 * Copyright (C) 2003-2005 The University of Waikato
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __SCAMPER_H
#define __SCAMPER_H

#define SCAMPER_ATTEMPTS_MIN  1
#define SCAMPER_ATTEMPTS_DEF  2
#define SCAMPER_ATTEMPTS_MAX  9
int scamper_attempts_get(void);
int scamper_attempts_set(const int attempts);

#define SCAMPER_DPORT_MIN     1024
#define SCAMPER_DPORT_DEF     (32768+777)
#define SCAMPER_DPORT_MAX     65535
int scamper_dport_get(void);
int scamper_dport_set(const int dport);

#define SCAMPER_HOLDTIME_MIN  0
#define SCAMPER_HOLDTIME_DEF  0
#define SCAMPER_HOLDTIME_MAX  255
int scamper_holdtime_get(void);
int scamper_holdtime_set(const int holdtime);

#define SCAMPER_HOPLIMIT_MIN  5
#define SCAMPER_HOPLIMIT_DEF  32
#define SCAMPER_HOPLIMIT_MAX  127    /* 127 is actually the hard limit */
int scamper_hoplimit_get(void);
int scamper_hoplimit_set(const int hoplimit);

#define SCAMPER_PPS_MIN       1
#define SCAMPER_PPS_MAX       1000
#define SCAMPER_PPS_DEF       20
int scamper_pps_get(void);
int scamper_pps_set(const int pps);

#define SCAMPER_SPORT_MIN     1
#define SCAMPER_SPORT_MAX     65535
int scamper_sport_get(void);
int scamper_sport_set(const int sport);

#define SCAMPER_TIMEOUT_MIN   1
#define SCAMPER_TIMEOUT_DEF   5
#define SCAMPER_TIMEOUT_MAX   10
int scamper_timeout_get(void);
int scamper_timeout_set(const int timeout);

int scamper_option_allattempts(void);
int scamper_option_detectloops(void);
int scamper_option_dl(void);
int scamper_option_ipv4(void);
int scamper_option_ipv6(void);
int scamper_option_pmtu(void);

void scamper_exitwhendone(const int on);

#define SCAMPER_VERSION "20050527"

#endif /* __SCAMPER_H */
