/*
 * scamper_addr.h
 *
 * $Id: scamper_addr.h,v 1.8 2005/05/04 10:38:54 mjl Exp $
 *
 * Copyright (C) 2004 The University of Waikato
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __SCAMPER_ADDR_H
#define __SCAMPER_ADDR_H

typedef struct scamper_addrcache scamper_addrcache_t;

#define SCAMPER_ADDR_TYPE_IPV4     0x01
#define SCAMPER_ADDR_TYPE_IPV6     0x02
#define SCAMPER_ADDR_TYPE_ETHERNET 0x03

typedef struct scamper_addr
{
  int   type;
  void *addr;
  int   refcnt;
  void *internal;
} scamper_addr_t;

scamper_addr_t *scamper_addr_alloc(const int type, const void *addr);
void scamper_addr_free(scamper_addr_t *sa);
scamper_addr_t *scamper_addr_use(scamper_addr_t *sa);

int scamper_addr_cmp(const scamper_addr_t *a, const scamper_addr_t *b);

size_t scamper_addr_size(const scamper_addr_t *sa);

const char *scamper_addr_tostr(const scamper_addr_t *sa,
			       char *dst, const size_t size);

scamper_addr_t *scamper_addrcache_get(scamper_addrcache_t *ac,
				      const int type, const void *addr);

scamper_addrcache_t *scamper_addrcache_alloc(void);
void scamper_addrcache_free(scamper_addrcache_t *ac);

#endif /* __SCAMPER_ADDR_H */
