/*
 * scamper_fds: manage events for file descriptors
 *
 * $Id: scamper_fds.h,v 1.7 2005/03/31 09:51:32 mjl Exp $
 *
 *          Matthew Luckie
 * 
 *          Supported by:
 *           The University of Waikato
 *           NLANR Measurement and Network Analysis
 *           CAIDA
 *           The WIDE Project
 *
 * Copyright (C) 2004 The University of Waikato
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __SCAMPER_FD_H
#define __SCAMPER_FD_H

#define SCAMPER_FD_ICMP4     0x01
#define SCAMPER_FD_ICMP6     0x02
#define SCAMPER_FD_UDP4      0x03
#define SCAMPER_FD_UDP6      0x04
#define SCAMPER_FD_TCP4      0x05
#define SCAMPER_FD_TCP6      0x06
#define SCAMPER_FD_DL        0x07
#define SCAMPER_FD_FILE      0x08

typedef void (*scamper_fd_cb_t)(const int fd, void *param);

typedef struct scamper_fd scamper_fd_t;

scamper_fd_t *scamper_fds_read_add(int fd, scamper_fd_cb_t cb, void *param);
scamper_fd_t *scamper_fds_write_add(int fd, scamper_fd_cb_t cb, void *param);

int scamper_fds_fd(const scamper_fd_t *fdn);

void scamper_fds_del(scamper_fd_t *fdn);

int scamper_fds_poll(struct timeval *timeout);

int scamper_fds_init(void);
void scamper_fds_cleanup(void);

#endif /* __SCAMPER_FD_H */
