/*
 * scamper_file.c
 *
 * $Id: scamper_file.h,v 1.8 2005/04/20 02:07:21 mjl Exp $
 *
 * entry points to read/write scamper traceroute and warts files, and to
 * read skitter arts files.
 *
 * Copyright (C) 2004 The University of Waikato
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __SCAMPER_FILE_H
#define __SCAMPER_FILE_H

typedef struct scamper_file scamper_file_t;

scamper_file_t *scamper_file_open(char *fn, char mode, char *type);
scamper_file_t *scamper_file_openfd(int fd, char *fn, char mode, char *type);
void scamper_file_close(scamper_file_t *sf);

scamper_trace_t *scamper_file_read_trace(scamper_file_t *sf);
int scamper_file_write_trace(scamper_file_t *sf, const scamper_trace_t *trace);

scamper_list_t *scamper_file_read_list(scamper_file_t *sf);

char *scamper_file_type_tostr(scamper_file_t *sf, char *buf, size_t len);
char *scamper_file_getfilename(scamper_file_t *sf);
int   scamper_file_eof(scamper_file_t *sf);

int   scamper_file_getfd(const scamper_file_t *sf);
void *scamper_file_getstate(const scamper_file_t *sf);
void  scamper_file_setstate(scamper_file_t *sf, void *state);

#endif /* __SCAMPER_FILE_H */
