/*
 * scamper_file_warts.h
 *
 * the Waikato ARTS file format replacement
 *
 * $Id: scamper_file_warts.h,v 1.6 2005/04/20 02:07:21 mjl Exp $
 *
 * code to read scamper's traceroute-like file format into scamper_hop
 * structures.
 *
 * Copyright (C) 2004 The University of Waikato
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __SCAMPER_FILE_WARTS_H
#define __SCAMPER_FILE_WARTS_H

scamper_trace_t *scamper_file_warts_read_trace(const scamper_file_t *file);

int scamper_file_warts_write_trace(const scamper_file_t *file,
				   const scamper_trace_t *trace);

scamper_list_t *scamper_file_warts_read_list(const scamper_file_t *file);

int scamper_file_warts_is(const scamper_file_t *file);
int scamper_file_warts_init_append(scamper_file_t *file);
int scamper_file_warts_init_read(scamper_file_t *file);
int scamper_file_warts_init_write(scamper_file_t *file);

void scamper_file_warts_close(scamper_file_t *file);

#endif /* __SCAMPER_FILE_WARTS_H */
