#ifndef __SCAMPER_PRIVSEP_H
#define __SCAMPER_PRIVSEP_H

#ifndef WITHOUT_PRIVSEP

#define SCAMPER_PRIVSEP_EXIT          0x00
#define SCAMPER_PRIVSEP_OPEN_DATALINK 0x01
#define SCAMPER_PRIVSEP_OPEN_FILE     0x02
#define SCAMPER_PRIVSEP_OPEN_RTSOCK   0x03

typedef struct scamper_privsep_msg
{
  uint8_t  type;
  void    *param;
  uint16_t len;
} scamper_privsep_msg_t;

int scamper_privsep_init(void);
void scamper_privsep_cleanup(void);
int scamper_privsep_getfd(const scamper_privsep_msg_t *msg);
int scamper_privsep_dotask(const scamper_privsep_msg_t *msg);

int scamper_privsep_openfile(const char *file,
			     const int flags, const mode_t mode);

#endif

#endif
